Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk.F90	(revision 13727)
@@ -1066,17 +1149,27 @@
       END DO
 
-      ! --- shortwave radiation transmitted below the surface (W/m2, see Grenfell Maykut 77) --- !
-      zfr1 = ( 0.18 * ( 1.0 - cldf_ice ) + 0.35 * cldf_ice )            ! transmission when hi>10cm
-      zfr2 = ( 0.82 * ( 1.0 - cldf_ice ) + 0.65 * cldf_ice )            ! zfr2 such that zfr1 + zfr2 to equal 1
-      !
-      WHERE    ( phs(:,:,:) <= 0._wp .AND. phi(:,:,:) <  0.1_wp )       ! linear decrease from hi=0 to 10cm
-         qtr_ice_top(:,:,:) = qsr_ice(:,:,:) * ( zfr1 + zfr2 * ( 1._wp - phi(:,:,:) * 10._wp ) )
-      ELSEWHERE( phs(:,:,:) <= 0._wp .AND. phi(:,:,:) >= 0.1_wp )       ! constant (zfr1) when hi>10cm
-         qtr_ice_top(:,:,:) = qsr_ice(:,:,:) * zfr1
-      ELSEWHERE                                                         ! zero when hs>0
-         qtr_ice_top(:,:,:) = 0._wp
-      END WHERE
-      !
-
+      ! --- shortwave radiation transmitted thru the surface scattering layer (W/m2) --- !
+      IF( nn_qtrice == 0 ) THEN
+         ! formulation derived from Grenfell and Maykut (1977), where transmission rate
+         !    1) depends on cloudiness
+         !    2) is 0 when there is any snow
+         !    3) tends to 1 for thin ice
+         ztri(:,:) = 0.18 * ( 1.0 - cloud_fra(:,:) ) + 0.35 * cloud_fra(:,:)  ! surface transmission when hi>10cm
+         DO jl = 1, jpl
+            WHERE    ( phs(:,:,jl) <= 0._wp .AND. phi(:,:,jl) <  0.1_wp )     ! linear decrease from hi=0 to 10cm  
+               qtr_ice_top(:,:,jl) = qsr_ice(:,:,jl) * ( ztri(:,:) + ( 1._wp - ztri(:,:) ) * ( 1._wp - phi(:,:,jl) * 10._wp ) )
+            ELSEWHERE( phs(:,:,jl) <= 0._wp .AND. phi(:,:,jl) >= 0.1_wp )     ! constant (ztri) when hi>10cm
+               qtr_ice_top(:,:,jl) = qsr_ice(:,:,jl) * ztri(:,:)
+            ELSEWHERE                                                         ! zero when hs>0
+               qtr_ice_top(:,:,jl) = 0._wp 
+            END WHERE
+         ENDDO
+      ELSEIF( nn_qtrice == 1 ) THEN
+         ! formulation is derived from the thesis of M. Lebrun (2019).
+         !    It represents the best fit using several sets of observations
+         !    It comes with snow conductivities adapted to freezing/melting conditions (see icethd_zdf_bl99.F90)
+         qtr_ice_top(:,:,:) = 0.3_wp * qsr_ice(:,:,:)
+      ENDIF
+      !
       IF( iom_use('evap_ao_cea') .OR. iom_use('hflx_evap_cea') ) THEN
          ztmp(:,:) = zevap(:,:) * ( 1._wp - at_i_b(:,:) )
@@ -1160,5 +1253,5 @@
          !
          DO jl = 1, jpl
-            DO_2D_11_11
+            DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
                zhe = ( rn_cnd_s * phi(ji,jj,jl) + rcnd_i * phs(ji,jj,jl) ) * zfac                            ! Effective thickness
                IF( zhe >=  zfac2 )   zgfac(ji,jj,jl) = MIN( 2._wp, 0.5_wp * ( 1._wp + LOG( zhe * zfac3 ) ) ) ! Enhanced conduction factor
@@ -1175,5 +1268,5 @@
       !
       DO jl = 1, jpl
-         DO_2D_11_11
+         DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
             !
             zkeff_h = zfac * zgfac(ji,jj,jl) / &                                    ! Effective conductivity of the snow-ice system divided by thickness
@@ -1323,5 +1416,5 @@
       zqi_sat(:,:) =                  q_sat( ptm_su(:,:), pslp(:,:) )   ! saturation humidity over ice   [kg/kg]
       !
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          ! Virtual potential temperature [K]
          zthetav_os = zst(ji,jj)    * ( 1._wp + rctv0 * zqo_sat(ji,jj) )   ! over ocean
@@ -1366,5 +1459,5 @@
          !
       END_2D
-      CALL lbc_lnk_multi( 'sbcblk', pcd, 'T',  1., pch, 'T', 1. )
+      CALL lbc_lnk_multi( 'sbcblk', pcd, 'T',  1.0_wp, pch, 'T', 1.0_wp )
       !
    END SUBROUTINE Cdn10_Lupkes2015
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_algo_coare3p0.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_algo_coare3p0.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_algo_coare3p0.F90	(revision 13727)
@@ -394,5 +394,5 @@
       !!-------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
       !
       zw = pwnd(ji,jj)   ! wind speed
@@ -430,5 +430,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
       !
       zta = pzeta(ji,jj)
@@ -481,5 +481,5 @@
       REAL(wp) :: zta, zphi_h, zphi_c, zpsi_k, zpsi_c, zf, zc, zstab
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
       !
       zta = pzeta(ji,jj)
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_algo_coare3p6.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_algo_coare3p6.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_algo_coare3p6.F90	(revision 13727)
@@ -430,5 +430,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
       !
       zta = pzeta(ji,jj)
@@ -481,5 +481,5 @@
       REAL(wp) :: zta, zphi_h, zphi_c, zpsi_k, zpsi_c, zf, zc, zstab
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
       !
       zta = pzeta(ji,jj)
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_algo_ecmwf.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_algo_ecmwf.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_algo_ecmwf.F90	(revision 13727)
@@ -410,5 +410,5 @@
       REAL(wp) :: zzeta, zx, ztmp, psi_unst, psi_stab, stab
       !!----------------------------------------------------------------------------------
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
       !
       zzeta = MIN( pzeta(ji,jj) , 5._wp ) !! Very stable conditions (L positif and big!):
@@ -455,5 +455,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
       !
       zzeta = MIN(pzeta(ji,jj) , 5._wp)   ! Very stable conditions (L positif and big!):
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_algo_ncar.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_algo_ncar.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_algo_ncar.F90	(revision 13727)
@@ -241,5 +241,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
          !
          zw  = pw10(ji,jj)
@@ -277,5 +277,5 @@
       REAL(wp) :: zx2, zx, zstab   ! local scalars
       !!----------------------------------------------------------------------------------
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
          zx2 = SQRT( ABS( 1._wp - 16._wp*pzeta(ji,jj) ) )
          zx2 = MAX( zx2 , 1._wp )
@@ -308,5 +308,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
          zx2 = SQRT( ABS( 1._wp - 16._wp*pzeta(ji,jj) ) )
          zx2 = MAX( zx2 , 1._wp )
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_phy.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_phy.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_phy.F90	(revision 13727)
@@ -181,5 +181,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
          ztc  = ptak(ji,jj) - rt0   ! air temp, in deg. C
          ztc2 = ztc*ztc
@@ -270,5 +270,5 @@
       INTEGER  ::   ji, jj         ! dummy loop indices
       !!----------------------------------------------------------------------------------
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
          gamma_moist_vctr(ji,jj) = gamma_moist_sclr( ptak(ji,jj), pqa(ji,jj) )
       END_2D
@@ -315,5 +315,5 @@
       !!-------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
          !
          zqa = (1._wp + rctv0*pqa(ji,jj))
@@ -351,5 +351,5 @@
       !!-------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
          !
          zqa = 0.5_wp*(pqa(ji,jj)+pssq(ji,jj))                                        ! ~ mean q within the layer...
@@ -448,5 +448,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
          !
          ze_sat =  e_sat_sclr( ptak(ji,jj) )
@@ -473,5 +473,5 @@
       !!----------------------------------------------------------------------------------
       !
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
          ze = prha(ji,jj)*e_sat_sclr(ptak(ji,jj))
          q_air_rh(ji,jj) = ze*reps0/(pslp(ji,jj) - (1. - reps0)*ze)
@@ -511,5 +511,5 @@
       INTEGER  ::   ji, jj     ! dummy loop indices
       !!----------------------------------------------------------------------------------
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
 
          zdt = pTa(ji,jj) - pTs(ji,jj) ;  zdt = SIGN( MAX(ABS(zdt),1.E-6_wp), zdt )
@@ -621,5 +621,5 @@
       IF( PRESENT(pfact_evap) ) zfact_evap = pfact_evap
 
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
 
          CALL BULK_FORMULA_SCLR( pzu, pTs(ji,jj), pqs(ji,jj), pTa(ji,jj), pqa(ji,jj), &
@@ -640,5 +640,5 @@
       !!                           ***  FUNCTION alpha_sw_vctr  ***
       !!
-      !! ** Purpose : ROUGH estimate of the thermal expansion coefficient of sea-water at the surface (P =~ 1010 hpa)
+      !! ** Purpose : ROUGH estimate of the thermal expansion coefficient of sea-water at the surface (i.e. P =~ 101000 Pa)
       !!
       !! ** Author: L. Brodeau, june 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
@@ -654,5 +654,5 @@
       !!                           ***  FUNCTION alpha_sw_sclr  ***
       !!
-      !! ** Purpose : ROUGH estimate of the thermal expansion coefficient of sea-water at the surface (P =~ 1010 hpa)
+      !! ** Purpose : ROUGH estimate of the thermal expansion coefficient of sea-water at the surface (i.e. P =~ 101000 Pa)
       !!
       !! ** Author: L. Brodeau, june 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_skin_coare.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_skin_coare.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_skin_coare.F90	(revision 13727)
@@ -89,5 +89,5 @@
       REAL(wp) :: zQabs, zdlt, zfr, zalfa, zqlat, zus
       !!---------------------------------------------------------------------
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
 
          zQabs = pQnsol(ji,jj) ! first guess of heat flux absorbed within the viscous sublayer of thicknes delta,
@@ -156,5 +156,5 @@
       ztime = REAL(nsec_day,wp)/(24._wp*3600._wp) ! time of current time step since 00:00 for current day (UTC) -> ztime = 0 -> 00:00 / ztime = 0.5 -> 12:00 ...
 
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
 
          l_exit       = .FALSE.
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_skin_ecmwf.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_skin_ecmwf.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcblk_skin_ecmwf.F90	(revision 13727)
@@ -95,5 +95,5 @@
       REAL(wp) :: zQabs, zdlt, zfr, zalfa, zus
       !!---------------------------------------------------------------------
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
 
          zQabs = pQnsol(ji,jj) ! first guess of heat flux absorbed within the viscous sublayer of thicknes delta,
@@ -173,5 +173,5 @@
       IF( PRESENT(pustk) ) l_pustk_known = .TRUE.
 
-      DO_2D_11_11
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
 
          zHwl = Hz_wl(ji,jj) ! first guess for warm-layer depth (and unique..., less advanced than COARE3p6 !)
